{--------------------------------------------------------}
{                                                        }
{    Grafivox - gerador de grficos para cegos           }
{                                                        }
{    Mdulo de arquivamento                              }
{                                                        }
{    Autor:  Jos Antonio Borges                         }
{                                                        }
{    Em agosto/2018                                      }
{                                                        }
{--------------------------------------------------------}

unit gfarq;

interface
uses windows, dvcrt, dvwin, dvarq, dvform, gfmsg, gfvars, sysUtils;

function GetTempFile(filetype: string): String;

function pegaNomeArq: string;
function carregaArquivo: boolean;
procedure salvaArquivo;
procedure novoGrafico;

implementation

{--------------------------------------------------------}
{          obtm o nome de um arquivo temporrio
{--------------------------------------------------------}

function GetTempFile(filetype: string): String;
var
    tempFileName, tempPath: array[0..255] of Char;
begin
    getTempPath (255, tempPath);
    getTempFileName(tempPath, pchar(filetype), 0, tempFileName);
    result := strPas (tempFileName);
end;

{--------------------------------------------------------}
{                   pega o nome do arquivo               }
{--------------------------------------------------------}

function pegaNomeArq: string;
var nome: string;
begin
    if paramCount > 0 then
        nome := trim (paramStr(1));

    if nome = '' then
        begin
            while keypressed do readkey;
            mensagem ('GFNOMARQ', 1);  {'Informe o nome do arquivo'}
            nome := obtemNomeArqMasc(10, '*.grm');
            if teclaObtemNomeArq = ESC then
                exit;

            if nome = '' then
                begin
                    mensagem ('GFASSUME', 1);  {'Assumido desenho.grm'}
                    nome := 'desenho.grm';
                end
            else
                writeln (nome);
        end;

    tituloJanela (nome);
    pegaNomeArq := nome;
end;

{--------------------------------------------------------}
{                   carrega o arquivo                    }
{--------------------------------------------------------}

function carregaArquivo: boolean;
begin
    if upperCase(copy (nomeArq, length(nomeArq)-3, 4)) <> '.GRM' then
        nomeArq := nomeArq + '.grm';

    result := false;
    if not FileExists(nomeArq) then
        begin
            mensagem ('GFARQNOV', 2);  {'Arquivo novo'}
            mensagem ('GFAPTF9', -1);  {'Aperte F9 para ajuda'}
            exit;
        end;

    listaComandos.LoadFromFile(nomeArq);
    mensagem ('GFARQCRG', 2);  {'Arquivo carregado'}
    result := true;
end;

{--------------------------------------------------------}
{                        salva o arquivo                 }
{--------------------------------------------------------}

procedure salvaArquivo;
begin
    mensagem ('GFSALVAR', 0);          {'Quer salvar o arquivo (S/N)? '}
    if popupMenuPorLetra('SN') <> 'S' then
        begin
            mensagem ('GFDESIST', 1);  {'Desistiu...'}
            exit;
        end;

    if nomeArq = '' then
        nomeArq := pegaNomeArq;

    if nomeArq <> '' then
        listaComandos.SaveToFile(nomeArq);
end;

{--------------------------------------------------------}
{                    cria novo grfico                   }
{--------------------------------------------------------}

procedure novoGrafico;
begin
    salvaArquivo;
    listaComandos.Clear;

    nomeArq := pegaNomeArq;
    if nomeArq <> '' then
        carregaArquivo;
end;

end.
